#include <iostream>
#include <algorithm>
using namespace std;

int main()
{
    int n;
    int k;
    int br = 1;
    int brp = 0;

    long long meta[1000000];
    long long menjaj[500000];

    cin>> n >> k;

    for (int i=0; i<n; i++)
    {
        cin>> meta[i];
    }

    sort(meta, meta + n);

    for(int i=0; i<n-1; i++)
    {
        if(meta[i] == meta[i+1])
        {
            br++;
            if(br == k)
            {
                menjaj[brp] = meta[i];
                brp++;
            }
        }
        else
        {
            br=1;
        }
    }

    for(int i=0; i<brp; i++)
    {
        cout<< menjaj[i] << " ";
    }
    
	return 0;
}